Description

Aloha,

I loaded geospatial view from Oracle (11g) in QGis 2.4. 

When I query on attributes, string like attributes are all right padded with white space character (in the follow exemple, TYPE_LIB and

AFF_LIB). My view seems correct when I query with sql on it in sqlplus.

Here the sql I used to create the view :

CREATE OR REPLACE FORCE VIEW "QGIS"."EXPORT_PA_LIBEL" 

(

   "GID",

   "GEOMETRY",

   "INSEE_CO",

   "RIVOLI_V",

   "LIBELLE",

   "TEXTE_L",

   "TEXTE_L_X",

   "TEXTE_L_Y",

   "TEXTE_L_O",

   "TYPE_LIB",

   "AFF_LIB" 

)

AS

   SELECT GID,

          GEOMETRY,

          CAST (INSEE_CO AS CHAR (5)),

          CAST (RIVOLI_V AS CHAR (4)),

          CAST (LIBELLE AS VARCHAR (200)),

          CAST (TEXTE_L AS VARCHAR (200)),

          CAST (TEXTE_L_X AS VARCHAR (50)),

          CAST (TEXTE_L_Y AS VARCHAR (50)),

          CAST (TEXTE_L_O AS VARCHAR (50)),

          CAST (TYPE_LIB AS CHAR (50)),

          CAST (AFF_LIB AS CHAR (50))

     FROM PA_LIBEL

   WITH READ ONLY;

Here a screenshot of attributes def in QGis.
http://i.imgur.com/R3cREG8.png

Is this a known problem ? Am I missing something ? It's pretty annoying when I intend to put etiquettes on features.

Thanks in advance

History

#1 - 2015-02-26 12:23 AM - Giovanni Manghi

- Affected QGIS version changed from 2.8.0 to 2.4.0

- Status changed from Open to Feedback

- Category changed from Attribute table to Data Provider/Oracle

Hi, could you give qgis 2.8/master a try and see if it still happen? thanks.

#2 - 2015-02-26 12:51 AM - Jürgen Fischer

Giovanni Manghi wrote:

Hi, could you give qgis 2.8/master a try and see if it still happen? thanks.

The difference between CHAR and VARCHAR is that the former is padded to the given length and the latter isn't.  See Overview of Character Datatypes

#3 - 2015-05-11 02:20 PM - Giovanni Manghi

- Resolution set to invalid

- Status changed from Feedback to Closed
http://docs.oracle.com/cd/B28359_01/server.111/b28318/datatype.htm#CNCPT213

